//====================================================================
//
// Purpose: Lists the HResults used by the Universal Runtime (URT).
// 
// Date: This file created on September 2, 1999.
//
// Copyright (C) 1999 Microsoft Corporation
//
//====================================================================
#ifndef __UNIVERSAL_RUNTIME_HRESULTS__
#define __UNIVERSAL_RUNTIME_HRESULTS__

/*********************************************************************

  The scheme for URT HResults was arbitrarily decided to follow this
  scheme:

  0x0000 Reserved for Windows error codes.
  0x1000 for the COM+ Runtime
  0x2000 for XSP
  0x3000 for Web Objects/messaging
  0x4000 for wit

  Due to logistical issues with our multiple source trees, this file
  only includes the HResults files for other portions of the URT.

*********************************************************************/

#ifndef FACILITY_URT
#define FACILITY_URT            0x13
#endif

#ifndef EMAKEHR
#define SMAKEHR(val)			MAKE_HRESULT(SEVERITY_SUCCESS, FACILITY_URT, val)
#define EMAKEHR(val)			MAKE_HRESULT(SEVERITY_ERROR, FACILITY_URT, val)
#endif


// ******************
// FACILITY_UTF
// ******************

#include <CorError.h>



#endif // __UNIVERSAL_RUNTIME_HRESULTS__
